package com.kernelmaft.zanbur.common



enum class ChangeSource { Local , Remote }

typealias CurrentSceneSubscriber = ( Group , Scene , ChangeSource ) -> Unit
typealias GroupAddedSubscriber = ( Group , ChangeSource ) -> Unit

object AppState {
	private val currentSceneSubscribers : MutableList <CurrentSceneSubscriber> = mutableListOf ()
	private val groupAddedSubscribers : MutableList <GroupAddedSubscriber> = mutableListOf ()

	fun setCurrentScene ( group : Group , newScene : Scene , source : ChangeSource ) {
		for ( subscriber in currentSceneSubscribers ) {
			subscriber ( group , newScene , source )
		}
	}
	fun subscribeToCurrentScene ( subscriber : CurrentSceneSubscriber ) {
		currentSceneSubscribers . add (subscriber)
	}

	fun addGroup ( newGroup : Group , source : ChangeSource ) {
		for ( subscriber in groupAddedSubscribers ) {
			subscriber ( newGroup , source )
		}
	}
	fun subscribeToGroupAdded ( subscriber : GroupAddedSubscriber ) {
		groupAddedSubscribers . add (subscriber)
	}
}
